const { RuntimeError } = require( 'o-toolbox' )
const BluePrintReference = require( './BluePrintReference' )

class BluePrintCommon {
  initialize () {

  }

  allowCommands ({ commands }) {
    commands.forEach( (command) => {
      this.allowCommand({ command })
    })
  }

  allowCommand ({ command }) {
    this.publicCommands.push( command )
  }

  allowAllMethodsAsCommands () {
    const propertyNames = Object.getOwnPropertyNames( Object.getPrototypeOf( this ) )
                            .filter( (prop) => ![ 'constructor', 'initialize' ].includes( prop ) )
    this.allowCommands({ commands: propertyNames })
  }

  asReference () {
    return new BluePrintReference({ bluePrint: this })
  }

  raiseCommandNotFoundError ({ command }) {
    const message = `The command '.${ command }()' is not defined. If it's present then it's not public, you might add it to the allowed commands with this.allowCommands(...)`
    RuntimeError.raise({ message })
  }
}

module.exports = BluePrintCommon