const MethodProxy = require( 'o-method-proxy' )
const ProxyDefinition = function (proxy) {
  proxy.on({
    absentMethod: function (proxy, target, methodName, args) {
      return target.evaluate({ command: methodName, params: args })
    }
  })
}

class BluePrintReference {
  constructor ({ bluePrint }) {
    this.target = bluePrint

    return MethodProxy.on( this, ProxyDefinition )
  }

  getClassName () {
    return this.target.getClassName()
  }

  asReference () {
    return this
  }

  evaluate ({ command, params }) {
    return this.target.evaluate({ command, params })
  }
}

module.exports = BluePrintReference